unit UShellExecuteEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses ShellAPI;
var SInfo: TShellExecuteInfo;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if OpenDialog1.Execute
  then begin
   SInfo.Wnd := Handle;
   SInfo.nShow := 0;
   if Sender = Button1
    then SInfo.lpVerb := 'open'
    else SInfo.lpVerb := 'edit';
   SInfo.lpFile := PChar(OpenDialog1.FileName);
   SInfo.cbSize := sizeof(SInfo);
   if not ShellExecuteEx(@SInfo)
   then case SInfo.hInstApp of
    SE_ERR_FNF: ShowMessage('  ');
    SE_ERR_PNF:	ShowMessage('  ');
    SE_ERR_ACCESSDENIED: ShowMessage('   ');
    SE_ERR_OOM: ShowMessage('  ');
    SE_ERR_DLLNOTFOUND: ShowMessage('   DLL');
    SE_ERR_SHARE: ShowMessage('   ');
    SE_ERR_ASSOCINCOMPLETE: ShowMessage('       ');
    SE_ERR_DDETIMEOUT: ShowMessage('     DDE');
    SE_ERR_DDEFAIL: ShowMessage('  DDE');
    SE_ERR_DDEBUSY: ShowMessage(' DDE ');
    SE_ERR_NOASSOC: ShowMessage(' ,   ');
   end
   else Button3.Enabled := true;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 SInfo.lpVerb := 'print';
 ShellExecuteEx(@SInfo);
end;

end.
 